#!/usr/bin/python
# -*- coding: utf-8 -*-
import bs4, urllib2, time, fileinput, sys,urllib

def parser(url,first):
    parsedtext = ''
    zaehler = 0
    page = urllib2.urlopen(url).read()
    soup = bs4.BeautifulSoup(page)
    zeilen = soup.find_all('td', {"class" : "overview timelink"})
    verspaetungen = soup.find_all('td', {"class" : "overview tprt"})
    if first:
        del zeilen[2:]
        del verspaetungen[2:]
    for zeile in zeilen:
        for zelle in zeile.children:
            parsedtext += zelle.contents[0].string
        parsedtext += '&nbsp;<span style="color:red;">'
        for verspaetung in verspaetungen[zaehler].children:
            if str(verspaetungen[zaehler]).count("okmsg") > 1 or str(verspaetungen[zaehler]).count("red") > 1:
                parsedtext += verspaetung.contents[0]
                break
        parsedtext += '</span><br>'
        zaehler += 1
    return(parsedtext)

textlist = []
textlist.append('<div id="bahn">')
timestamp = time.localtime(time.time())
if timestamp[6] > 4:
    textlist.append("<b>Bahnanzeige erst am Montag wieder!<br>Sch&ouml;nes Wochenende!</b><br>")
elif timestamp[3] > 17:
    textlist.append("<b>Bahnanzeige erst morgen wieder!</b><br>")
elif timestamp[3] < 8:
    textlist.append("<b>Aktuelle Abfahrtszeiten Grevenbroich:</b><br>")
    textlist.append(parser("http://reiseauskunft.bahn.de/bin/query.exe/dox?S=8000133&Z=8000208&time=07:00&start=1",0))
    textlist.append(parser("http://reiseauskunft.bahn.de/bin/query.exe/dox?S=8000133&Z=8000208&time=08:00&start=1",1))
elif timestamp[3] < 16:
    textlist.append("<b>Bahnanzeige erst wieder ab 16 Uhr!</b><br>")
else:
    textlist.append("<b>Aktuelle Abfahrtszeiten Ehrenfeld:</b><br>")
    textlist.append(parser("http://reiseauskunft.bahn.de/bin/query.exe/dox?S=8000208&Z=8000133&time=17:00&start=1",0))
    textlist.append(parser("http://reiseauskunft.bahn.de/bin/query.exe/dox?S=8000208&Z=8000133&time=18:00&start=1",1))
textlist.append("</div>\n")
text = "<br>".join(textlist)

for line in fileinput.FileInput("/home/pi/anzeige/bahnlinks.html",inplace=1):
   if line.startswith('<div id="bahn">'):
       line = text
   sys.stdout.write(line)


